<?php
/**
 * ATTENTION : ANSI ()
 * [21/04/2005] Version 1.0
 * [23/04/2005] Version 1.1
 * Support des filtres supplmentaires
 * 
 * @ignore
 */
/**
 * Reformate un texte
 * @package			com.neolao
 * @subpackage		data
 * @author			neolao <neo@neolao.com>
 * @version			1.1 (23/04/2005)
 * @link			http://resources.neolao.com/php/classes/data/textformat
 */
class TextFormat {
	// ----------------------------- CONSTANTES --------------------------------
	
	// ----------------------------- VARIABLES ---------------------------------
	/**
	 * Les filtres de recherche
	 * @var array
	 */
	static $patterns;
	/**
	 * Les remplacements
	 * @var array
	 */
	static $replacements;
	/**
	 * Les filtres de recherche supplmentaires
	 * @var array
	 */
	static $newpatterns;
	/**
	 * Les remplacements supplmentaires
	 * @var array
	 */
	static $newreplacements;
	/**
	 * Les options
	 * @var array
	 */
	static $options;
	/*=========================== METHODES PRIVEES ===========================*/
	/*========================================================================*/
	/**
	 * Initialisation des variables
	 */
	static protected function _init(){
		self::$patterns = array();
		self::$replacements = array();
		
		// -------------- Filtres supplmenaires
		for($i=0; $i<count(self::$newpatterns); $i++){
			self::$patterns[] = self::$newpatterns[$i];
			self::$replacements[] = self::$newreplacements[$i];
		}
	}
	/*===================== FIN = METHODES PRIVEES = FIN =====================*/
	/*========================================================================*/

	/*============================ GETTER  SETTER ============================*/
	/*========================================================================*/
	/**
	 * Dfini si un remplacement est actif ou pas
	 * @param string $name Le nom de la proprit
	 * @param bool $value true pour activer l'option et false pour la dsactiver
	 */
	static public function setOption($name, $value){
		if(!isset(self::$options)){
			self::$options = array();
		}
		self::$options[$name] = $value;
	}
	/**
	 * Rcupre une prorit (une proprit est active par dfaut)
	 * @param string $name Le nom de la proprit
	 * @return bool true si la proprit est active, sinon false
	 */
	static public function getOption($name){
		if(isset(self::$options[$name])){
			return self::$options[$name];
		}else{
			return true;
		}
	}
	/*====================== FIN = GETTER  SETTER = FIN ======================*/
	/*========================================================================*/

	/*========================== METHODES PUBLIQUES ==========================*/
	/*========================================================================*/
	/**
	 * Reformate le texte
	 * @param string $text Le texte  formater
	 * @return string Le nouveau texte format
	 */
	static public function format($text){
		return preg_replace(self::$patterns, self::$replacements, $text);
	}
	/**
	 * Ajouter un filtre
	 * @param string $pattern Le filtre
	 * @param string $replacement Le remplacement
	 */
	static public function addPattern($pattern, $replacement){
		if(!isset(self::$newpatterns)){
			self::$newpatterns = array();
			self::$newreplacements = array();
		}
		if(isset($pattern) && isset($replacement)){
			self::$newpatterns[] = $pattern;
			self::$newreplacements[] = $replacement;
		}
	}
	/*==================== FIN = METHODES PUBLIQUES = FIN ====================*/
	/*========================================================================*/
}
?>
