<?php
/**
 * ATTENTION : ANSI ()
 * [21/04/2005] Version 1.0
 * [23/04/2005] Version 1.1
 * Modification de quelques filtres
 * [24/04/2005] Version 2.0
 * Changement de la conception gnrale :
 * - Il y a maintenant 2 types de remplacements, block et inline
 * - Les remplacements inline se font dans les block
 * [28/04/2005] Version 2.1
 * Correction d'un bug sur les url :
 * - quand on crit un tag [[http://www.perdu.com|http://www.perdu.com]]
 * 
 * @ignore
 */
require_once "TextFormat.php";
/**
 * Reformate un texte wiki en html
 * 
 * @package			com.neolao
 * @subpackage		data
 * @author			neolao <neo@neolao.com>
 * @version			2.1 (28/04/2005)
 * @link			http://resources.neolao.com/php/classes/data/wiki2html
 */
class Wiki2html extends TextFormat{
	// ----------------------------- CONSTANTES --------------------------------
	
	// ----------------------------- VARIABLES ---------------------------------
	
	/*=========================== METHODES PRIVEES ===========================*/
	/*========================================================================*/
	/**
	 * Initialisation des variables
	 */
	static protected function _init(){
		// Rinitialisation des filtres
		parent::_init();
		
		// -------------- URL automatique
		if(self::getOption("urlauto")){
			self::$patterns[] = '_(^|[^\[\|\(])http://([^ <\r\n\'"]+)_';
			self::$replacements[] = '$1<a href="http://$2">http://$2</a>';
		}
		// -------------- URL avec [[url|titre|langue]]
		if(self::getOption("url")){
			// [[url]]
			self::$patterns[] = "_\[\[([^\|]+)\]\]_";
			self::$replacements[] = '<a href="$1">$1</a>';
			// [[url|titre]]
			self::$patterns[] = "_\[\[([^\|]+)\|([^\|]+)\]\]_";
			self::$replacements[] = '<a href="$1">$2</a>';
			// [[url|titre|langue]]
			self::$patterns[] = "_\[\[([^\|]+)\|([^\|]+)\|([a-z]+)\]\]_";
			self::$replacements[] = '<a href="$1" hreflang="$3">$2</a>';
		}
		// -------------- STRONG avec **texte**
		if(self::getOption("strong")){
			self::$patterns[] = "|\*\*([^<]*?)\*\*|";
			self::$replacements[] = "<strong>$1</strong>";
		}
		// -------------- INS avec __texte__
		if(self::getOption("ins")){
			self::$patterns[] = "|__([^<]*?)__|";
			self::$replacements[] = "<ins>$1</ins>";
		}
		// -------------- EM avec ''texte''
		if(self::getOption("em")){
			self::$patterns[] = "|''([^<]*?)''|";
			self::$replacements[] = "<em>$1</em>";
		}
		// -------------- DEL avec --texte--
		if(self::getOption("del")){
			self::$patterns[] = "|\-\-([^<]*?)\-\-|";
			self::$replacements[] = "<del>$1</del>";
		}
		// -------------- IMAGE avec ((url))
		if(self::getOption("image")){
			self::$patterns[] = "_(^| |>|\n)\(\(([^<]*?)\)\)_";
			self::$replacements[] = '$1<img src="$2" alt="" />';
		}
		// -------------- ACRONYM avec ??PC|Personnal Computer??
		if(self::getOption("acronym")){
			self::$patterns[] = "_\?\?([^\|<]+)\|?([^\|<]+)\?\?_";
			self::$replacements[] = '<acronym title="$2">$1</acronym>';
		}
		
	}
	/**
	 * Le traitement de remplacement. Ca passe d'abord par les blocks.
	 * @param string $text Le texte  formater
	 * @return string L'quivalent html
	 */
	static protected function _tagsBlock($text){
		// $a = split("\r\n", $text);
		$a = split("(\r\n|\r|\n)", $text);
		// $a = split("[\r\n]", $text);
		
		$inBlock = false;
		for($i=0; $i<count($a); $i++){
			if(empty($a[$i])){
				// ligne vide
				//array_splice($a, $i, 1);
				//$i--; 
			}else{
				// -------------- PRE avec ####
				if(self::getOption("pre") && (!$inBlock || ($inBlock && $blockType == "pre"))){
					if(!$inBlock && ereg("^####$", $a[$i], $regs) !== false){
						// Dbut du block
						$a[$i] = "<pre>";
						$inBlock = true;
						$blockType = "pre";
						if($i == count($a) - 1){
							// Fin de message
							$a[$i] .= "</pre>\n";
						}
					}else if($inBlock && ereg("^####$", $a[$i], $regs) === false){
						// Toujours dans le block  plusieurs lignes
						$a[$i] = $a[$i]."\n";
						if($i == count($a) - 1){
							// Fin de message
							$a[$i] .= "</pre>\n";
						}
					}else if($inBlock && ereg("^####$", $a[$i], $regs) !== false){
						// Fin du block  plusieurs lignes
						$a[$i] = "</pre>\n";
						$inBlock = false;
					}
				}
				// -------------- BLOCKQUOTE avec ****
				if(self::getOption("blockquote") && (!$inBlock || ($inBlock && $blockType == "blockquote"))){
					if(!$inBlock && ereg("^\*\*\*\*$", $a[$i], $regs) !== false){
						// Dbut du block
						$a[$i] = "<blockquote>";
						$inBlock = true;
						$blockType = "blockquote";
						if($i == count($a) - 1){
							// Fin de message
							$a[$i] .= "</blockquote>\n";
						}
					}else if($inBlock && ereg("^\*\*\*\*$", $a[$i], $regs) === false){
						// Toujours dans le block  plusieurs lignes
						$a[$i] = parent::format($a[$i])."<br />\n";
						if($i == count($a) - 1){
							// Fin de message
							$a[$i] .= "</blockquote>\n";
						}
					}else if($inBlock && ereg("^\*\*\*\*$", $a[$i], $regs) !== false){
						// Fin du block  plusieurs lignes
						$a[$i] = "</blockquote>\n";
						$inBlock = false;
					}
				}
				
				// -------------- UL avec   *
				if(self::getOption("ul") && (!$inBlock || ($inBlock && $blockType == "ul"))){
					if(!$inBlock && ereg("^  \*(.+)", $a[$i], $regs) !== false){
						// Dbut du block
						$a[$i] = "<ul><li>".parent::format($regs[1])."</li>\n";
						$inBlock = true;
						$blockType = "ul";
						if($i == count($a) - 1){
							// Fin de message
							$a[$i] .= "</ul>\n";
						}
					}else if($inBlock && ereg("^  \*(.+)", $a[$i], $regs) !== false){
						// Intrieur du block
						$a[$i] = "<li>".parent::format($regs[1])."</li>\n";
						if($i == count($a) - 1){
							// Fin de message
							$a[$i] .= "</ul>\n";
						}
					}else if($inBlock){
						// Fin du block
						$a[$i - 1] .= "</ul>\n";
						$inBlock = false;
						$i--;
					}
				}
				
				// -------------- OL avec   #
				if(self::getOption("ol") && (!$inBlock || ($inBlock && $blockType == "ol"))){
					if(!$inBlock && ereg("^  \#(.+)", $a[$i], $regs) !== false){
						// Dbut du block
						$a[$i] = "<ol><li>".parent::format($regs[1])."</li>\n";
						$inBlock = true;
						$blockType = "ol";
						if($i == count($a) - 1){
							// Fin de message
							$a[$i] .= "</ol>\n";
						}
					}else if($inBlock && ereg("^  \#(.+)", $a[$i], $regs) !== false){
						// Intrieur du block
						$a[$i] = "<li>".parent::format($regs[1])."</li>\n";
						if($i == count($a) - 1){
							// Fin de message
							$a[$i] .= "</ol>\n";
						}
					}else if($inBlock){
						// Fin du block
						$a[$i - 1] .= "</ol>\n";
						$inBlock = false;
						$i--;
					}
				}
				
				// -------------- Paragraphe
				if(!$inBlock && ereg("</", $a[$i], $regs) === false){
					if(ereg("</p>\n$", $a[$i - 1], $regs) !== false){
						$a[$i - 1] = substr($a[$i - 1], 0, strlen($a[$i - 1]) - 5)."<br />\n";
						$a[$i] = parent::format($a[$i])."</p>\n";
					}else{
						$a[$i] = "<p>".parent::format($a[$i])."</p>\n";
					}
				}
			}
		}
		return implode("", $a);
	}
	/*===================== FIN = METHODES PRIVEES = FIN =====================*/
	/*========================================================================*/

	/*============================ GETTER  SETTER ============================*/
	/*========================================================================*/
	
	/*====================== FIN = GETTER  SETTER = FIN ======================*/
	/*========================================================================*/

	/*========================== METHODES PUBLIQUES ==========================*/
	/*========================================================================*/
	/**
	 * Reformate le texte
	 * @param string $text Le texte  formater
	 * @return string Le nouveau texte format
	 */
	static public function format($text){
		self::_init();
		return self::_tagsBlock($text);
	}
	/*==================== FIN = METHODES PUBLIQUES = FIN ====================*/
	/*========================================================================*/
}
?>
