<?php
/**
 * ATTENTION : ANSI ()
 * [02/03/2005] Version 1.0
 * [10/03/2005] Version 1.1
 * Ajout des mthodes :
 * - insert
 * - select
 * - update
 * - delete
 * [04/04/2005] Version 1.2
 * Ajout de la proprit $lastQuery
 * 
 * [07/04/2005] Version 1.3
 * Modification de la dclaration de la mthode select
 * 
 * [09/04/2005] Version 1.4
 * Ajout de la mthode fetch_single
 * 
 * [16/04/2005] Version 1.5
 * Ajout de la mthode replace
 * 
 * [11/05/2005] Version 1.6
 * Ajout de la mthode _escape, qui permet d'chapper les valeurs, contre les injections sql
 * 
 * [31/05/2005] Version 1.7
 * Ajout d'une proprit connected qui indique si la connexion  la base est tablie
 * 
 * @ignore
 */
require_once 'IDatabase.php';
require_once 'DatabaseUtils.php';
/**
 * Class de base pour la gestion d'une base de donnes
 * @package			com.neolao
 * @subpackage		database
 * @author 			neolao <neo@neolao.com>
 * @version 		1.7 (31/05/2005)
 * @link			http://resources.neolao.com/php/classes/database/adatabasebasic
 */
abstract class ADatabaseBasic implements IDatabase {
	// ----------------------------- VARIABLES ---------------------------------
	/**
	 * Instance d'une classe de connexion correspondant au type de la base
	 * @var connection
	 */
	protected $CLSconnection;
	/**
	 * Rsultat de la dernire requte
	 * @var resource
	 */
	protected $RSCresultQuery;
	/**
	 * Dernire requte effectue
	 * @var string
	 */
	public $lastRequest;
	
	/*=========================== METHODES PRIVEES ===========================*/
	/*========================================================================*/
	/**
	 * Echapper les valeurs, contre les injections SQL
	 * @param mixed $value La valeur  chapper
	 * @return string La valeur chappe
	 */
	protected function _escape($value){
		return DatabaseUtils::escape($value);
	}
	/*===================== FIN = METHODES PRIVEES = FIN =====================*/
	/*========================================================================*/
	
	/*============================ GETTER  SETTER ============================*/
	/*========================================================================*/
	public function __get($var){
		switch($var){
			case "connected":
				// Indique si la connexion est tablie
				return ($this->CLSconnection->getResource() !== false)?true:false;
			default:
				return null;
		}
	}
	/*====================== FIN = GETTER  SETTER = FIN ======================*/
	/*========================================================================*/
	
	/*========================== METHODES PUBLIQUES ==========================*/
	/*========================================================================*/
	/**
	 * Se connecter  la base
	 */
	public function connect(){
		
	}
	/**
	 * Se dconnecter de la base
	 */
	public function disconnect(){
		if(!is_null($this->CLSconnection)){
			$this->CLSconnection->close();
		}
	}
	/**
	 * Faire une requte
	 */
	public function query($request){
		
	}
	/**
	 * Insrer des donnes dans une table
	 */
	public function insert($table, $columns, $values){
		
	}
	/**
	 * Insrer des donnes dans une table si elles n'existent pas, sinon la met  jour
	 */
	public function replace($table, $columns, $values){
	
	}
	/**
	 * Slection
	 */
	public function select($table, $columns=null, $condition=null, $group=null, $having=null, $order=null, $limit=null, $sendRequest=true){
		
	}
	/**
	 * Modification
	 */
	public function update($table, $columns, $values, $condition=null){
		
	}
	/**
	 * Suppression
	 */
	public function delete($table, $condition=null){
		
	}
	/**
	 * Retourne la prochaine ligne du rsultat de la requte
	 */
	public function fetch_array(){
		
	}
	/**
	 * Retourne la valeur du premier champ du rsultat de la requte
	 */
	public function fetch_single(){
	
	}
	/*==================== FIN = METHODES PUBLIQUES = FIN ====================*/
	/*========================================================================*/
}
?>