<?php
/**
 * ATTENTION : ANSI ()
 * [02/03/2005] Version 1.0
 * [10/03/2005] Version 1.1
 * Ajout des mthodes :
 * - insert
 * - select
 * - update
 * - delete
 * 
 * [07/04/2005] Version 1.2
 * Modification de la dclaration de la mthode select
 * 
 * [09/04/2005] Version 1.3
 * Ajout de la mthode fetch_single
 * 
 * [16/04/2005] Version 1.4
 * Ajout de la mthode replace
 * 
 * @ignore
 */
/**
 * Interface de gestion de base de donnes
 * @package			com.neolao
 * @subpackage		database
 * @author			neolao <neo@neolao.com>
 * @version			1.4 (16/04/2005)
 * @link			http://resources.neolao.com/php/classes/database/idatabase
 */
interface IDatabase {
	/**
	 * Se connecter  la base
	 */
	public function connect();
	/**
	 * Se dconnecter de la base
	 */
	public function disconnect();
	/**
	 * Faire une requte
	 */
	public function query($request);
	/**
	 * Insrer des donnes dans une table
	 */
	public function insert($table, $columns, $values);
	/**
	 * Insrer des donnes dans une table si elles n'existent pas, sinon la met  jour
	 */
	public function replace($table, $columns, $values);
	/**
	 * Slection
	 */
	public function select($table, $columns=null, $condition=null, $group=null, $having=null, $order=null, $limit=null, $sendRequest=true);
	/**
	 * Modification
	 */
	public function update($table, $columns, $values, $condition=null);
	/**
	 * Suppression
	 */
	public function delete($table, $condition=null);
	/**
	 * Retourne la prochaine ligne du rsultat de la requte
	 * false si termin
	 */
	public function fetch_array();
	/**
	 * Retourne la valeur du premier champ du rsultat de la requte
	 */
	public function fetch_single();
}
?>
