<?php
/**
 * ATTENTION : ANSI ()
 * [10/03/2005] Version 1.1
 * [30/03/2005] Version 1.2
 * Modification de la mthode select
 * => On peut maintenant passer en paramtre table, un array pour une jointure
 * 
 * [04/04/2005] Version 1.3
 * Enregistrement de la dernire requte
 * 
 * [07/04/2005] Version 1.4
 * Modification de la mthode select
 * 
 * [09/04/2005] Version 1.5
 * Ajout de la mthode fetch_single
 * 
 * [16/04/2005] Version 1.6
 * Ajout de la mthode replace
 * 
 * [11/05/2005] Version 1.7
 * Utilisation de _escape
 * 
 * [01/06/2005] Version 1.8
 * Modification de la mthode insert, un bug si on passe un nombre en paramtre
 * 
 * [03/06/2005] Version 1.9
 * Modification de la mthode replace, un bug si on passe un nombre en paramtre
 * 
 * @ignore
 */
require_once "ADatabaseBasic.php";
require_once "IDatabase.php";
require_once realpath(dirname(__FILE__)."/../../../")."/com/neolao/connection/ConnectionMySQL.php";
/**
 * Gestionnaire de requtes MySQL
 * @package			com.neolao
 * @subpackage		database
 * @author			neolao <neo@neolao.com>
 * @version			1.9 (03/06/2005)
 * @link			http://resources.neolao.com/php/classes/database/mysqlmanager
 */
class MySQLManager extends ADatabaseBasic implements IDatabase{
	// ----------------------------- CONSTANTES --------------------------------
	
	// ----------------------------- VARIABLES ---------------------------------
	
	// ----------------------------- EVENEMENTS --------------------------------
	
	/*===================== CONSTRUCTEUR & DESCTRUCTEUR ======================*/
	/*========================================================================*/
	/**
	 * Initialisation de la class
	 * @param string $server Le serveur de base de donnes
	 * @param string $database Le nom de la base de donnes
	 * @param string $login L'identifiant de connexion
	 * @param string $password Le mot de passe
	 */
	function MySQLManager($server, $database, $login, $password){
		
		if(!is_null($server) && !is_null($database) && !is_null($login) && !is_null($password)){
			$this->CLSconnection = new ConnectionMySQL($server, $database, $login, $password);
		}
	}
	/**
	 * Destruction de la class
	 */
	function __destruct(){
	
	}
	/*=============== FIN = CONSTRUCTEUR & DESCTRUCTEUR = FIN ================*/
	/*========================================================================*/

	/*=========================== METHODES PRIVEES ===========================*/
	/*========================================================================*/
	
	/*===================== FIN = METHODES PRIVEES = FIN =====================*/
	/*========================================================================*/

	/*============================ GETTER  SETTER ============================*/
	/*========================================================================*/

	/*====================== FIN = GETTER  SETTER = FIN ======================*/
	/*========================================================================*/

	/*========================== METHODES PUBLIQUES ==========================*/
	/*========================================================================*/
	/**
	 * Connexion  la base
	 * @return bool true si la connexion a russi, sinon false
	 */
	public function connect(){
		$argsTotal = func_num_args(); // Nombre d'arguments
		$argsList = func_get_args(); // Liste des arguments
		$server = $argsList[0];
		$database = $argsList[1];
		$login = $argsList[2];
		$password = $argsList[3];
		
		parent::connect($server, $database, $login, $password);
		return $this->CLSconnection->connect($server, $database, $login, $password);
	}
	/**
	 * Dconnexion de la base
	 */
	public function disconnect(){
		parent::disconnect();
	}
	/**
	 * Effectue une requte
	 * @param string $request La requte
	 * @return resource Le rsultat de la requte
	 */
	public function query($request){
		parent::query($request);
		$result = false;
		
		if($this->CLSconnection && !is_null($request)){
			$this->lastRequest = $request;
			$result = mysql_query($request, $this->CLSconnection->getResource());
			$this->RSCresultQuery = $result;
		}
		
		return $result;
	}
	/**
	 * Insrer un ligne dans une table
	 * 
	 * // Equivalent de : INSERT INTO tb_users(name) VALUES("toto")
	 * $monManager->insert("tb_users", "name", "toto");
	 * // Equivalent de : INSERT INTO tb_users(name, age) VALUES("toto", 18)
	 * $monManager->insert("tb_users", array("name", "age"), array("toto", 18));
	 * // Equivalent de : INSERT INTO tb_users(name, age) VALUES("toto", 18), ("mimi", 17)
	 * $monManager->insert("tb_users", array("name", "age"), array(array("toto", 18), array("mimi", 17));
	 * 
	 * @param string $table La table
	 * @param mixed $columns Les colonnes  modifier
	 * @param mixed $values Les valeur des colonnes
	 * @return bool true si l'opration a russi, sinon false
	 */
	public function insert($table, $columns, $values){
		parent::insert($table, $columns, $values);
		
		$request = "INSERT INTO ";
		$request .= $table;
		
		// colonnes
		if(is_string($columns)){
			// le paramtre est un string
			$request .= "(";
			$request .= $columns;
			$request .= ")";
		}elseif(is_array($columns)){
			// le paramtre est un tableau
			$request .= "(";
			$coma = "";
			for($i=0; $i<count($columns); $i++){
				$request .= $coma.$columns[$i];
				$coma = ", ";
			}
			$request .= ")";
		}
		
		// valeurs
		$request .= " VALUES ";
		if(!is_array($values)){
			// le paramtre est un string
			$request .= "(";
			$request .= $this->_escape($values);
			$request .= ")";
		}else{
			// le paramtre est un tableau
			if(!is_array($values[0])){
				// pas un tableau, donc insertion d'une seule ligne
				$request .= "(";
				$coma = "";
				for($i=0; $i<count($values); $i++){
					$request .= $coma;
					$request .= $this->_escape($values[$i]);
					$coma = ", ";
				}
				$request .= ")";
			}else{
				// tableau, donc insertion de plusieurs lignes
				$requestGen = $request;
				for($i=0; $i<count($values); $i++){
					$requestTmp = $requestGen;
					$requestTmp .= "(";
					$coma = "";
					for($j=0; $j<count($values[$i]); $j++){
						$requestTmp .= $coma;
						$requestTmp .= $this->_escape($values[$i][$j]);
						$coma = ", ";
					}
					$requestTmp .= ")";
					
					if(!$this->query($requestTmp)){
						return false;
					}
				}
				return true;
			}
		}
		return $this->query($request);
	}
	/**
	 * Insrer un ligne dans une table si elle n'existe pas, sinon la met  jour
	 * L'un des champ doit tre unique, sinon cette mthode aura le mme comportement que insert
	 * 
	 * // Equivalent de : REPLACE INTO tb_users(name) VALUES("toto")
	 * $monManager->replace("tb_users", "name", "toto");
	 * // Equivalent de : REPLACE INTO tb_users(name, age) VALUES("toto", 18)
	 * $monManager->replace("tb_users", array("name", "age"), array("toto", 18));
	 * // Equivalent de : REPLACE INTO tb_users(name, age) VALUES("toto", 18), ("mimi", 17);
	 * $monManager->replace("tb_users", array("name", "age"), array(array("toto", 18), array("mimi", 17));
	 * 
	 * @param string $table La table
	 * @param mixed $columns Les colonnes  modifier
	 * @param mixed $values Les valeur des colonnes
	 * @return bool true si l'opration a russi, sinon false
	 */
	public function replace($table, $columns, $values){
		parent::replace($table, $columns, $values);
		
		$request = "REPLACE INTO ";
		$request .= $table;
		
		// colonnes
		
		if(is_string($columns)){
			// le paramtre est un string
			
			$request .= "(";
			$request .= $columns;
			$request .= ")";
		}elseif(is_array($columns)){
			// le paramtre est un tableau
			
			$request .= "(";
			$coma = "";
			for($i=0; $i<count($columns); $i++){
				$request .= $coma.$columns[$i];
				$coma = ", ";
			}
			$request .= ")";
		}
		
		// valeurs
		
		$request .= " VALUES ";
		if(!is_array($values)){
			// le paramtre est un string
			$request .= "(";
			$request .= $this->_escape($values);
			$request .= ")";
		}else{
			// le paramtre est un tableau
			if(!is_array($values[0])){
				// pas un tableau, donc insertion d'une seule ligne
				$request .= "(";
				$coma = "";
				for($i=0; $i<count($values); $i++){
					$request .= $coma;
					$request .= $this->_escape($values[$i]);
					$coma = ", ";
				}
				$request .= ")";
			}else{
				// tableau, donc insertion de plusieurs lignes
				$requestGen = $request;
				for($i=0; $i<count($values); $i++){
					$requestTmp = $requestGen;
					$requestTmp .= "(";
					$coma = "";
					for($j=0; $j<count($values[$i]); $j++){
						$requestTmp .= $coma;
						$requestTmp .= $this->_escape($values[$i][$j]);
						$coma = ", ";
					}
					$requestTmp .= ")";
					
					if(!$this->query($requestTmp)){
						return false;
					}
				}
				return true;
			}
		}
		return $this->query($request);
	}
	/**
	 * Slection
	 * 
	 * // Equivalent de : SELECT name FROM tb_users WHERE id=1
	 * $monManager->select("tb_users", "name", "id=1");
	 * // Equivalent de : SELECT name, age FROM tb_users WHERE id=1
	 * $monManager->select("tb_users", array("name", "age"), "id=1");
	 * // Equivalent de : SELECT classe, niveau FROM tb_users GROUP BY classe ORDER BY niveau DESC LIMIT 0, 10
	 * $monManager->select("tb_users", array("classe", "niveau"), null, "classe", array("niveau"=>"DESC"), array(0, 10));
	 * 
	 * @param mixed $table La table ou les tables
	 * @param mixed $columns Les colonnes  rcuprer
	 * @param string $condition Les conditions de recherche des lignes
	 * @param string $group Rangement par groupe
	 * @param string $having Slection gnralement avec un GROUP BY
	 * @param array $order Triage (tableau cl=>valeur, o la cl correspond  une colonne de la table et valeur  "DESC" ou "ASC")
	 * @param array $limit Limitation des lignes (tableau  2 cellules, le premier correspond  l'index de dpart, et le second au nombre de lignes slectionnes)
	 * @param bool $sendRequest true pour envoyer la requte et retourner le rsultat, sinon retourne la chane de requte
	 * @return mixed Si $sendRequest=true alors indique le succs de l'opration, sinon retourne la chane de requte
	 */
	public function select($table, $columns=null, $condition=null, $group=null, $having=null, $order=null, $limit=null, $sendRequest=true){
		parent::select($table, $columns, $condition, $group, $having, $order, $limit);
		
		$request = "SELECT ";
		if(is_string($columns)){
			// le paramtre est un string
			$request .= $columns;
		}elseif(is_array($columns)){
			// le paramtre est un tableau
			$coma = "";
			for($i=0; $i<count($columns); $i++){
				$request .= $coma;
				$request .= $columns[$i];
				$coma = ", ";
			}
		}else{
			$request .= "*";
		}
		
		// table
		$request .= " FROM ";
		if(is_array($table)){
			$request .= implode(", ", $table);
		}else{
			$request .= $table;
		}
		
		// condition
		if(!is_null($condition)){
			$request .= " WHERE ";
			$request .= $condition;
		}
		
		// group
		if(!is_null($group)){
			$request .= " GROUP BY ";
			$request .= $group;
		}
		
		// having
		if(!is_null($having)){
			$request .= " HAVING ";
			$request .= $having;
		}
		
		// order
		if(!is_null($order)){
			$request .= " ORDER BY ";
			$coma = "";
			while (list ($key, $value) = each($order)) {
				$request .= $key." ".$value;
				$coma = ", ";
			}
			
		}
		
		// limit
		if(!is_null($limit)){
			$request .= " LIMIT ";
			$request .= $limit[0];
			$request .= ", ";
			$request .= $limit[1];
		}
		
		return ($sendRequest)?$this->query($request):$request;
	}
	/**
	 * Fabriquation de requte SELECT
	 * 
	 * // Equivalent de : SELECT * FROM tb_users WHERE idClasse IN (SELECT id FROM tb_classes WHERE niveau=1)
	 * $monManager->select("tb_users", "*", "idClasse IN (".$monManager->selectMaker("tb_classes", "id", "niveau=1").")");>
	 * 
	 * @param mixed $table La table ou les tables
	 * @param mixed $columns Les colonnes  rcuprer
	 * @param string $condition Les conditions de recherche des lignes
	 * @param string $group Rangement par groupe
	 * @param string $having Slection gnralement avec un GROUP BY
	 * @param array $order Triage (tableau cl=>valeur, o la cl correspond  une colonne de la table et valeur  "DESC" ou "ASC")
	 * @param array $limit Limitation des lignes (tableau  2 cellules, le premier correspond  l'index de dpart, et le second au nombre de lignes slectionnes)
	 * @param bool $sendRequest true pour envoyer la requte et retourner le rsultat, sinon retourne la chane de requte
	 * @return string La chane de requte
	 */
	public function selectMaker($table, $columns=null, $condition=null, $group=null, $having=null, $order=null, $limit=null){
		return select($table, $columns, $condition, $group, $having, $order, $limit, false);
	}
	/**
	 * Modification
	 * 
	 * // Equivalent de : UPDATE tb_users SET age=20 WHERE id=24
	 * $monManager->update("tb_users", "age", "20", "id=24");
	 * // Equivalent de : UPDATE tb_users SET age=20, vieux='true' WHERE id=24
	 * $monManager->update("tb_users", array("age", "vieux"), array("20", "'true'"), "id=24");
	 * // Equivalent de : UPDATE tb_users SET age=age+1 WHERE id=24
	 * $monManager->update("tb_users", "age", "age+1", "id=24");
	 * 
	 * @param string $table La table ou les tables
	 * @param mixed $columns Les colonnes  modifier
	 * @param mixed $values Les valeur des colonnes
	 * @param string $condition Les conditions de recherche des lignes
	 * @return bool true si l'opration a russi, sinon false
	 */
	public function update($table, $columns, $values, $condition=null){
		parent::update($table, $columns, $values, $condition);
		
		$request = "UPDATE ";
		
		// table
		if(is_array($table)){
			$request .= implode(", ", $table);
		}else{
			$request .= $table;
		}
		
		// set
		$request .= " SET ";
		if(is_string($columns)){
			// le paramtre est un string
			// donc un seul champ  modifier, donc $value n'est pas un tableau non plus
			$request .= $columns;
			$request .= "=";
			$request .= $this->_escape($values);
		}elseif(is_array($columns)){
			// le paramtre est un tableau
			$coma = "";
			for($i=0; $i<count($columns); $i++){
				$request .= $coma;
				$request .= $columns[$i];
				$request .= "=";
				$request .= $this->_escape($values[$i]);
				$coma = ", ";
			}
		}
		
		// condition
		if(!is_null($condition)){
			$request .= " WHERE ";
			$request .= $condition;
		}
		
		return $this->query($request);
	}
	/**
	 * Suppression
	 * 
	 * // Equivalent de : DELETE FROM tb_users WHERE id=24
	 * $monManager->delete("tb_users", "id=24");
	 * // Equivalent de : DELETE FROM tb_users USING tb_users, tb_classes WHERE tb_users.idClasse=tb_classes.id AND tb_classes.name LIKE 'orc_%'
	 * $monManager->delete(array("tb_users", array("tb_users", "tb_classes")), "tb_users.idClasse=tb_classes.id AND tb_classes.name LIKE 'orc_%'");
	 * 
	 * @param mixed $table La table ou les tables
	 * @param string $condition Les conditions de recherche des lignes
	 * @return bool true si l'opration a russi, sinon false
	 */
	public function delete($table, $condition=null){
		parent::delete($table, $condition);
		
		$request = "DELETE FROM ";
		
		// table
		if(is_array($table)){
			$request .= implode(", ", $table[0]);
			$request .= " USING ";
			$request .= implode(", ", $table[1]);
		}else{
			$request .= $table;
		}
		
		// condition
		if(!is_null($condition)){
			$request .= " WHERE ";
			$request .= $condition;
		}
		
		return $this->query($request);
	}
	/**
	 * Retourne la prochaine ligne du rsultat de la requte
	 * @return array La ligne, false si termin
	 */
	public function fetch_array(){
		parent::fetch_array();
		if($this->RSCresultQuery !== false){
			return mysql_fetch_array($this->RSCresultQuery);
		}else{
			return false;
		}
	}
	/**
	 * Retourne la valeur du premier champ du rsultat de la requte
	 * @return string La valeur, sinon false
	 */
	public function fetch_single(){
		parent::fetch_single();
		if($this->RSCresultQuery !== false){
			$row = mysql_fetch_row($this->RSCresultQuery);
			return $row[0];
		}else{
			return false;
		}
	}
	/*==================== FIN = METHODES PUBLIQUES = FIN ====================*/
	/*========================================================================*/
}
?>