-- 
-- Structure de la table `apo_bookmarks`
-- 

DROP TABLE IF EXISTS `apo_bookmarks`;
CREATE TABLE `apo_bookmarks` (
  `id` int(11) NOT NULL auto_increment,
  `parentId` int(11) NOT NULL default '0',
  `type` varchar(6) NOT NULL default 'link',
  `level` int(1) NOT NULL default '0',
  `name` varchar(200) NOT NULL default '',
  `url` varchar(200) NOT NULL default 'http://',
  `userId` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

-- 
-- Structure de la table `apo_bookmarks_groups`
-- 

DROP TABLE IF EXISTS `apo_bookmarks_groups`;
CREATE TABLE `apo_bookmarks_groups` (
  `id` int(11) NOT NULL auto_increment,
  `parentId` int(11) NOT NULL default '0',
  `type` varchar(6) NOT NULL default 'link',
  `level` int(1) NOT NULL default '0',
  `name` varchar(50) NOT NULL default '',
  `url` varchar(100) NOT NULL default 'http://',
  `groupId` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

-- 
-- Structure de la table `apo_calendar`
-- 

DROP TABLE IF EXISTS `apo_calendar`;
CREATE TABLE `apo_calendar` (
  `id` int(11) NOT NULL auto_increment,
  `userId` int(11) NOT NULL default '0',
  `category` int(2) NOT NULL default '1',
  `title` varchar(200) NOT NULL default '',
  `dateStart` datetime NOT NULL default '0000-00-00 00:00:00',
  `dateEnd` datetime NOT NULL default '0000-00-00 00:00:00',
  `description` text NOT NULL,
  `repeatType` int(2) NOT NULL default '0',
  `repeatStep` int(2) NOT NULL default '1',
  `repeatEnd` datetime NOT NULL default '0000-00-00 00:00:00',
  `repeatEndNo` char(3) NOT NULL default 'off',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

-- 
-- Structure de la table `apo_contacts`
-- 

DROP TABLE IF EXISTS `apo_contacts`;
CREATE TABLE `apo_contacts` (
  `id` int(11) NOT NULL auto_increment,
  `userId` int(11) NOT NULL default '0',
  `contactId` int(11) NOT NULL default '0',
  `firstName` varchar(30) NOT NULL default '',
  `lastName` varchar(30) NOT NULL default '',
  `name` varchar(50) NOT NULL default '',
  `nickName` varchar(50) NOT NULL default '',
  `phoneHome` varchar(20) NOT NULL default '',
  `phoneCell` varchar(20) NOT NULL default '',
  `phoneWork` varchar(20) NOT NULL default '',
  `adress` text NOT NULL,
  `adress2` text NOT NULL,
  `city` varchar(200) NOT NULL default '',
  `state` varchar(100) NOT NULL default '',
  `adresscode` varchar(20) NOT NULL default '',
  `country` varchar(100) NOT NULL default '',
  `birthday` date NOT NULL default '0000-00-00',
  `email` varchar(100) NOT NULL default '',
  `email2` varchar(100) NOT NULL default '',
  `website` varchar(200) NOT NULL default '',
  `workJob` varchar(30) NOT NULL default '',
  `workDepartment` varchar(50) NOT NULL default '',
  `workCompany` varchar(50) NOT NULL default '',
  `workAdress` text NOT NULL,
  `workAdress2` text NOT NULL,
  `workCity` varchar(50) NOT NULL default '',
  `workState` varchar(50) NOT NULL default '',
  `workAdresscode` varchar(20) NOT NULL default '',
  `workCountry` varchar(100) NOT NULL default '',
  `workWebsite` varchar(100) NOT NULL default '',
  `note` text NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

-- 
-- Structure de la table `apo_groups`
-- 

DROP TABLE IF EXISTS `apo_groups`;
CREATE TABLE `apo_groups` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `description` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

-- 
-- Structure de la table `apo_news`
-- 

DROP TABLE IF EXISTS `apo_news`;
CREATE TABLE `apo_news` (
  `id` int(11) NOT NULL auto_increment,
  `userId` int(11) NOT NULL default '0',
  `categoryId` int(11) NOT NULL default '1',
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `title` varchar(50) NOT NULL default '',
  `message` text NOT NULL,
  `image` text NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

-- 
-- Structure de la table `apo_news_categories`
-- 

DROP TABLE IF EXISTS `apo_news_categories`;
CREATE TABLE `apo_news_categories` (
  `id` int(11) NOT NULL auto_increment,
  `nameClass` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;
INSERT INTO `apo_news_categories` VALUES (1, 'general');
INSERT INTO `apo_news_categories` VALUES (2, 'computers');
INSERT INTO `apo_news_categories` VALUES (3, 'games');
INSERT INTO `apo_news_categories` VALUES (4, 'gag');
INSERT INTO `apo_news_categories` VALUES (5, 'party');
INSERT INTO `apo_news_categories` VALUES (6, 'images');
INSERT INTO `apo_news_categories` VALUES (7, 'internet');
INSERT INTO `apo_news_categories` VALUES (8, 'music');
INSERT INTO `apo_news_categories` VALUES (9, 'people');
INSERT INTO `apo_news_categories` VALUES (10, 'meeting');
INSERT INTO `apo_news_categories` VALUES (11, 'movies');
INSERT INTO `apo_news_categories` VALUES (12, 'software');
INSERT INTO `apo_news_categories` VALUES (13, 'hardware');

-- 
-- Structure de la table `apo_news_comments`
-- 

DROP TABLE IF EXISTS `apo_news_comments`;
CREATE TABLE `apo_news_comments` (
  `id` int(11) NOT NULL auto_increment,
  `newsId` int(11) NOT NULL default '0',
  `userId` int(11) NOT NULL default '0',
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `message` text NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

-- 
-- Structure de la table `apo_rss`
-- 

DROP TABLE IF EXISTS `apo_rss`;
CREATE TABLE `apo_rss` (
  `id` int(11) NOT NULL auto_increment,
  `userId` int(11) NOT NULL default '0',
  `name` varchar(100) NOT NULL default '',
  `url` varchar(200) NOT NULL default '',
  `lastCheck` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

-- 
-- Structure de la table `apo_rss_archives`
-- 

DROP TABLE IF EXISTS `apo_rss_archives`;
CREATE TABLE `apo_rss_archives` (
  `id` int(11) NOT NULL auto_increment,
  `url` varchar(100) NOT NULL default '',
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `link` varchar(200) NOT NULL default '',
  `title` varchar(200) NOT NULL default '',
  `description` text NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `link` (`link`)
) TYPE=MyISAM;

-- 
-- Structure de la table `apo_todos`
-- 

DROP TABLE IF EXISTS `apo_todos`;
CREATE TABLE `apo_todos` (
  `id` int(11) NOT NULL auto_increment,
  `userId` int(11) NOT NULL default '0',
  `title` varchar(200) NOT NULL default '',
  `description` text NOT NULL,
  `status` int(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

-- 
-- Structure de la table `apo_users`
-- 

DROP TABLE IF EXISTS `apo_users`;
CREATE TABLE `apo_users` (
  `id` int(11) NOT NULL auto_increment,
  `createDate` datetime NOT NULL default '0000-00-00 00:00:00',
  `name` varchar(20) NOT NULL default '',
  `password` varchar(32) NOT NULL default '',
  `lastLogin` datetime NOT NULL default '0000-00-00 00:00:00',
  `admin` varchar(5) NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`)
) TYPE=MyISAM;

-- 
-- Structure de la table `apo_users_groups`
-- 

DROP TABLE IF EXISTS `apo_users_groups`;
CREATE TABLE `apo_users_groups` (
  `id` int(11) NOT NULL auto_increment,
  `userId` int(11) NOT NULL default '0',
  `groupId` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

-- 
-- Structure de la table `apo_users_infos`
-- 

DROP TABLE IF EXISTS `apo_users_infos`;
CREATE TABLE `apo_users_infos` (
  `id` int(11) NOT NULL auto_increment,
  `userId` int(11) NOT NULL default '0',
  `level` int(1) NOT NULL default '1',
  `firstName` varchar(30) NOT NULL default '',
  `lastName` varchar(30) NOT NULL default '',
  `birthday` date NOT NULL default '0000-00-00',
  `phoneHome` varchar(20) NOT NULL default '',
  `phoneCell` varchar(20) NOT NULL default '',
  `phoneWork` varchar(20) NOT NULL default '',
  `adress` text NOT NULL,
  `adress2` text NOT NULL,
  `city` varchar(200) NOT NULL default '',
  `state` varchar(100) NOT NULL default '',
  `adresscode` varchar(20) NOT NULL default '',
  `country` varchar(100) NOT NULL default '',
  `email` varchar(100) NOT NULL default '',
  `email2` varchar(100) NOT NULL default '',
  `website` varchar(200) NOT NULL default '',
  `workJob` varchar(30) NOT NULL default '',
  `workDepartment` varchar(50) NOT NULL default '',
  `workCompany` varchar(50) NOT NULL default '',
  `workAdress` text NOT NULL,
  `workAdress2` text NOT NULL,
  `workCity` varchar(50) NOT NULL default '',
  `workState` varchar(50) NOT NULL default '',
  `workAdresscode` varchar(20) NOT NULL default '',
  `workCountry` varchar(100) NOT NULL default '',
  `workWebsite` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `userId` (`userId`)
) TYPE=MyISAM;

-- 
-- Structure de la table `apo_users_preferences`
-- 

DROP TABLE IF EXISTS `apo_users_preferences`;
CREATE TABLE `apo_users_preferences` (
  `id` int(11) NOT NULL auto_increment,
  `userId` int(11) NOT NULL default '0',
  `news_total` int(5) NOT NULL default '10',
  `bookmarks_link_popup` int(1) NOT NULL default '1',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `userId` (`userId`)
) TYPE=MyISAM;