<?php
if($apo->loged){
	import("com.neolao.components.Calendar");
	import("com.neolao.components.CalendarWeek");
	import("com.neolao.components.CalendarDay");
	include_once dirname(__FILE__)."/../general/functions_html.inc";
	include_once dirname(__FILE__)."/functions.inc";
	
	// Initialisation
	$calendar_view = new Calendar("calendar_view");
	$calendar_view->monthNames = $monthNames;
	$calendar_view->dayNames = $dayNamesShort;
	$calendar_view->firstDay = 1;
	$calendarWeek_view = new CalendarWeek("calendar_week_view");
	$calendarWeek_view->dayNames = array($dayNames[1], 
									$dayNames[2], 
									$dayNames[3], 
									$dayNames[4], 
									$dayNames[5], 
									$dayNames[6], 
									$dayNames[0]);
	$calendarDay_view = new CalendarDay("calendar_day_view");
	$calendarDay_view->timeline = $hourNames;
	
	
	// Récupération des variables
	if(FormUtils::getParam("year") !== false){
		$calendar_view->year = FormUtils::getParam("year");
	}
	if(FormUtils::getParam("month") !== false){
		$calendar_view->month = FormUtils::getParam("month");
	}
	if(FormUtils::getParam("day") !== false){
		$calendar_view->day = FormUtils::getParam("day");
	}
	
	/* ------------------------------------------------*
	 *                  Calendar View                  *
	 *-------------------------------------------------*/
	$calendar_view->addNextYear($apo->webIndex."?p=calendar&amp;year=".($calendar_view->year + 1)."&amp;month=".$calendar_view->month."&amp;day=".$calendar_view->day);
	$calendar_view->addPreviousYear($apo->webIndex."?p=calendar&amp;year=".($calendar_view->year - 1)."&amp;month=".$calendar_view->month."&amp;day=".$calendar_view->day);
	$calendar_view->addNextMonth($apo->webIndex."?p=calendar&amp;year=".$calendar_view->year."&amp;month=".($calendar_view->month + 1)."&amp;day=".$calendar_view->day);
	$calendar_view->addPreviousMonth($apo->webIndex."?p=calendar&amp;year=".$calendar_view->year."&amp;month=".($calendar_view->month - 1)."&amp;day=".$calendar_view->day);
	$dayTotal = date("t", mktime(0, 0, 0, $calendar_view->month, 1, $calendar_view->year));
	// Pour chaque jour ...
	for($i=1; $i<=$dayTotal; $i++){
		// Ajout du lien dans le composant
		$calendar_view->addLink($i, $apo->webIndex."?p=calendar&amp;year=".$calendar_view->year."&amp;month=".$calendar_view->month."&amp;day=".$i);
		// Ajout d'un événement s'il y en a un
		// On a juste besoin de savoir s'il existe un événement, pas besoin de détails
		$dayTimestamp = mktime(0, 0, 0, $calendar_view->month, $i, $calendar_view->year);
		
		// Requete de récupération des événements qui commence ce jour
		$apo->db->select($apo->dbPrefix."calendar", "COUNT(*) AS total", "userId=".$apo->userId." AND dateStart LIKE '".date("Y-m-d", $dayTimestamp)."%'");
		$total1 = $apo->db->fetch_single();
		// Requete de récupération des événements qui commence dans le passé et qui se termine après 00h00 de ce jour
		$apo->db->select($apo->dbPrefix."calendar", "COUNT(*) AS total", "userId=".$apo->userId." AND dateStart < '".date("Y-m-d H:i:s", $dayTimestamp)."' AND dateEnd > '".date("Y-m-d H:i:s", $dayTimestamp)."'");
		$total2 = $apo->db->fetch_single();
		// Une requete dans la table contacts pour récupérer les anniversaires
		$apo->db->select($apo->dbPrefix."contacts", "COUNT(*) AS total", "userId=".$apo->userId." AND birthday LIKE '%".date("-m-d", $dayTimestamp)."' AND birthday > '1970-01-01'");
		$total3 = $apo->db->fetch_single();
		// Une autre requete sur l'intersection des membres et contacts pour récupérer les anniversaires synchronisés
		$apo->db->select(array($apo->dbPrefix."contacts AS a", $apo->dbPrefix."users AS b", $apo->dbPrefix."users_infos AS c"), "COUNT(*) AS total", "a.userId=".$apo->userId." AND b.name=a.nickName AND c.userId=b.id AND c.birthday LIKE '%".date("-m-d", $dayTimestamp)."' AND c.birthday > '1970-01-01'");
		$total4 = $apo->db->fetch_single();
		
		// A partir d'ici, si $events contient quelque chose, c'est qu'il y a un événement, pas besoin d'aller plus loin
		if($total1 > 0 || $total2 > 0 || $total3 > 0 || $total4 > 0){
			// Il y a un événement normal
			$calendar_view->addEvent($i);
		}else{
			// Il n'y a pas d'événement normal, il faut vérifier les événements périodiques
			
			// Requete de récupération des événements qui commence dans le passé et qui se répète après 00h00 de ce jour
			$apo->db->select($apo->dbPrefix."calendar", "*", "userId=".$apo->userId." AND dateStart < '".date("Y-m-d H:i:s", $dayTimestamp)."' AND (repeatEnd > '".date("Y-m-d H:i:s", $dayTimestamp)."' OR repeatEndNo='on')");
			$events = array();
			while($row = $apo->db->fetch_array()){
				$events[] = $row;
			}
			// Pour chaque événement repeat trouvé ...
			for($j=0; $j<count($events); $j++){
				$repeatType = $events[$j]["repeatType"]; // 0=jour, 1=semaine, 2=mois, 3=année
				$repeatStep = $events[$j]["repeatStep"];
				$startTimestamp = strtotime($events[$j]["dateStart"]);
				$startYear = date("Y", $startTimestamp);
				$startMonth = date("n", $startTimestamp);
				$startDay = date("j", $startTimestamp);
				
				// Il faut vérifier si cette répétition tombe aujourd'hui
				$ok = false;
				switch($repeatType){
					case 0:
						$startDayTimestamp = mktime(0, 0, 0, $startMonth, $startDay, $startYear);
						$testTimestamp = $dayTimestamp - $startDayTimestamp;
						if($testTimestamp % ($repeatStep*60*60*24) == 0){
							$ok = true;
						}
						break;
					case 1:
						$startDayTimestamp = mktime(0, 0, 0, $startMonth, $startDay, $startYear);
						$testTimestamp = $dayTimestamp - $startDayTimestamp;
						if($testTimestamp % ($repeatStep*60*60*24*7) == 0){
							$ok = true;
						}
						break;
					case 2:
						if($startDay == $weekFirstDay+$i){
							$ok = true;
						}
						break;
					case 3:
						if($startDay == $weekFirstDay+$i && $startMonth == $calendar_view->month){
							$ok = true;
						}
						break;
				}
				
				if($ok){
					// Il y a un événement ce jour
					$calendar_view->addEvent($i);
				}
			}
		}
	}
	
	/* ------------------------------------------------*
	 *               Calendar Week View                *
	 *-------------------------------------------------*/
	$weekNumber = date("W", mktime(0, 0, 0, $calendar_view->month, $calendar_view->day, $calendar_view->year));
	$calendarWeek_view->title = $apo->getText("date_week")." ".$weekNumber;
	// On cherche le premier jour de la semaine (lundi)
	$i = 0;
	while($weekNumber == date("W", mktime(0, 0, 0, $calendar_view->month, $calendar_view->day - $i, $calendar_view->year))){
		$i++;
	}
	$weekFirstDay = $calendar_view->day - $i + 1;
	// On met les liens sur les jours
	$dayNamesWeek = array();
	for($i=0; $i<=7; $i++){
		$dayNamesWeek[$i] = "<a href=\"".$apo->webIndex."?p=calendar&amp;year=".$calendar_view->year."&amp;month=".$calendar_view->month."&amp;day=".($weekFirstDay+$i)."\">".$calendarWeek_view->dayNames[$i]."</a>";
	}
	$calendarWeek_view->dayNames = $dayNamesWeek;
	// Pour chaque jour de la semaine, on cherche les événements
	for($i=0; $i<=7; $i++){
		$events = array();
		$dayTimestamp = mktime(0, 0, 0, $calendar_view->month, $weekFirstDay+$i, $calendar_view->year);
		// Requete de récupération des événements qui commence ce jour
		$apo->db->select($apo->dbPrefix."calendar", "*", "userId=".$apo->userId." AND dateStart LIKE '".date("Y-m-d", $dayTimestamp)."%'", null, null, array("dateStart"=>"ASC"));
		while($row = $apo->db->fetch_array()){
			$events[] = $row;
		}
		// Requete de récupération des événements qui commence dans le passé et qui se termine après 00h00 de ce jour
		$apo->db->select($apo->dbPrefix."calendar", "*", "userId=".$apo->userId." AND dateStart < '".date("Y-m-d H:i:s", $dayTimestamp)."' AND dateEnd > '".date("Y-m-d H:i:s", $dayTimestamp)."'", null, null, array("dateStart"=>"ASC"));
		while($row = $apo->db->fetch_array()){
			$events[] = $row;
		}
		// Une autre requete dans la table contacts pour récupérer les anniversaires
		$apo->db->select($apo->dbPrefix."contacts", "*", "userId=".$apo->userId);
		$contactsList = array();
		while($row = $apo->db->fetch_array()){
			$contactsList[] = $row;
		}
		for($j=0; $j<count($contactsList); $j++){
			$o = $contactsList[$j];
			$ok = false;
			if($o["birthday"] > "1970-01-01"){
				// La date est valide
				if(date("m-d", strtotime($o["birthday"])) == date("m-d", $dayTimestamp)){
					$ok = true;
				}
			}else{
				// La date n'est pas valide, on va chercher si c'est un anniversaire synchronisé
				$apo->db->select($apo->dbPrefix."users", "*", "name='".$o["nickName"]."'");
				$row = $apo->db->fetch_array();
				if($row !== false){
					// L'utilisateur existe, on récupère ses informations
					$apo->db->select($apo->dbPrefix."users_infos", "birthday", "userId=".$row["id"]." AND birthday LIKE '%".date("-m-d", $dayTimestamp)."'");
					$row = $apo->db->fetch_array();
					if($row !== false){
						// Il n'y a aucune vérification sur l'appartenance au groupe
						// Il est donc possible de connaître l'anniversaire de n'importe qui (super intéressant lol)
						$o = $row;
						$o["name"] = $contactsList[$j]["name"];
						$ok = true;
					}
				}
			}
			if($ok){
				$o["title"] = $apo->getText("calendar_event_category2")." : ".$o["name"];
				$o["description"] = "";
				$o["dateStart"] = "00:00";
				$o["category"] = "2";
				$o["id"] = "";
				$events[] = $o;
			}
		}
		// Requete de récupération des événements qui commence dans le passé et qui se répète après 00h00 de ce jour
		$apo->db->select($apo->dbPrefix."calendar", "*", "userId=".$apo->userId." AND dateStart < '".date("Y-m-d H:i:s", $dayTimestamp)."' AND (repeatEnd > '".date("Y-m-d H:i:s", $dayTimestamp)."' OR repeatEndNo='on')", null, null, array("dateStart"=>"ASC"));
		while($row = $apo->db->fetch_array()){
			$o = $row;
			$o["isRepeat"] = true;
			$events[] = $o;
		}
		
		// Affichage des événements du jour
		for($j=0; $j<count($events); $j++){
			if($events[$j]["isRepeat"]){
				// Evénement de type repeat
				$repeatType = $events[$j]["repeatType"]; // 0=jour, 1=semaine, 2=mois, 3=année
				$repeatStep = $events[$j]["repeatStep"];
				$startTimestamp = strtotime($events[$j]["dateStart"]);
				$startYear = date("Y", $startTimestamp);
				$startMonth = date("n", $startTimestamp);
				$startDay = date("j", $startTimestamp);
				
				// Il faut vérifier si cette répétition tombe aujourd'hui
				$ok = false;
				switch($repeatType){
					case 0:
						$startDayTimestamp = mktime(0, 0, 0, $startMonth, $startDay, $startYear);
						$testTimestamp = $dayTimestamp - $startDayTimestamp;
						if($testTimestamp % ($repeatStep*60*60*24) == 0){
							$ok = true;
						}
						break;
					case 1:
						$startDayTimestamp = mktime(0, 0, 0, $startMonth, $startDay, $startYear);
						$testTimestamp = $dayTimestamp - $startDayTimestamp;
						if($testTimestamp % ($repeatStep*60*60*24*7) == 0){
							$ok = true;
						}
						break;
					case 2:
						if($startDay == $weekFirstDay+$i){
							$ok = true;
						}
						break;
					case 3:
						if($startDay == $weekFirstDay+$i && $startMonth == $calendar_view->month){
							$ok = true;
						}
						break;
				}
				
				if($ok){
					$title = utf2html(htmlentities($events[$j]["title"], ENT_QUOTES, "UTF-8"));
					$description = nl2br(utf2html(htmlentities($events[$j]["description"], ENT_QUOTES, "UTF-8")));
					$dateStart = date("H:i", strtotime($events[$j]["dateStart"]));
					$calendarWeek_view->addEvent($i, $title, $dateStart, $apo->getLink("calendar_eventedit".$events[$j]["id"]), $description, 10, "event".$events[$j]["category"]);
				}
			}else{
				$title = utf2html(htmlentities($events[$j]["title"], ENT_QUOTES, "UTF-8"));
				$description = nl2br(utf2html(htmlentities($events[$j]["description"], ENT_QUOTES, "UTF-8")));
				$dateStart = date("H:i", strtotime($events[$j]["dateStart"]));
				$link = (!empty($events[$j]["id"]))?$apo->getLink("calendar_eventedit".$events[$j]["id"]):"#";
				$calendarWeek_view->addEvent($i, $title, $dateStart, $link, $description, 10, "event".$events[$j]["category"]);
			}
		}
	}
	
	/* ------------------------------------------------*
	 *                Calendar Day View                *
	 *-------------------------------------------------*/
	$search = array();	
	$search[] = "January";
	$search[] = "February";
	$search[] = "March";
	$search[] = "April";
	$search[] = "May";
	$search[] = "June";
	$search[] = "July";
	$search[] = "August";
	$search[] = "September";
	$search[] = "October";
	$search[] = "November";
	$search[] = "December";
	
	$search[] = "Sunday";
	$search[] = "Monday";
	$search[] = "Tuesday";
	$search[] = "Wednesday";
	$search[] = "Thursday";
	$search[] = "Friday";
	$search[] = "Saturday";
	
	$replace = array_merge($monthNames, $dayNames);
	
	$currentYear = $calendar_view->year;
	$currentMonth = $calendar_view->month;
	$currentDay = $calendar_view->day;
	$currentTimestamp = mktime(0, 0, 0, $currentMonth, $currentDay, $currentYear);
	$currentDate = date("l j F Y", $currentTimestamp);
	$currentDate = str_replace($search, $replace, $currentDate);
	
	$calendarDay_view->title = $currentDate;
	
	$events = array();
	// Requete de récupération des événements qui commence ce jour
	$apo->db->select($apo->dbPrefix."calendar", "*", "userId=".$apo->userId." AND dateStart LIKE '".date("Y-m-d", $currentTimestamp)."%'");
	while($row = $apo->db->fetch_array()){
		$events[] = $row;
	}
	// Requete de récupération des événements qui commence dans le passé et qui se termine après 00h00 de ce jour
	$apo->db->select($apo->dbPrefix."calendar", "*", "userId=".$apo->userId." AND dateStart < '".date("Y-m-d H:i:s", $currentTimestamp)."' AND dateEnd > '".date("Y-m-d H:i:s", $currentTimestamp)."'");
	while($row = $apo->db->fetch_array()){
		$events[] = $row;
	}
	// Une autre requete dans la table contacts pour récupérer les anniversaires
	$apo->db->select($apo->dbPrefix."contacts", "*", "userId=".$apo->userId);
	$contactsList = array();
	while($row = $apo->db->fetch_array()){
		$contactsList[] = $row;
	}
	for($j=0; $j<count($contactsList); $j++){
		$o = $contactsList[$j];
		$ok = false;
		if($o["birthday"] > "1970-01-01"){
			// La date est valide
			if(date("m-d", strtotime($o["birthday"])) == date("m-d", $currentTimestamp)){
				$ok = true;
			}
		}else{
			// La date n'est pas valide, on va chercher si c'est un anniversaire synchronisé
			$apo->db->select($apo->dbPrefix."users", "*", "name='".$o["nickName"]."'");
			$row = $apo->db->fetch_array();
			if($row !== false){
				// L'utilisateur existe, on récupère ses informations
				$apo->db->select($apo->dbPrefix."users_infos", "birthday", "userId=".$row["id"]." AND birthday LIKE '%".date("-m-d", $currentTimestamp)."'");
				$row = $apo->db->fetch_array();
				if($row !== false){
					// Il n'y a aucune vérification sur l'appartenance au groupe
					// Il est donc possible de connaître l'anniversaire de n'importe qui (super intéressant lol)
					$o = $row;
					$o["name"] = $contactsList[$j]["name"];
					$ok = true;
				}
			}
		}
		if($ok){
			$o["title"] = $apo->getText("calendar_event_category2")." : ".$o["name"];
			$o["description"] = "";
			$o["dateStart"] = date("Y-m-d 00:00", $currentTimestamp);
			$o["dateEnd"] = date("Y-m-d 23:59", $currentTimestamp);
			$o["category"] = "2";
			$o["id"] = "";
			$events[] = $o;
		}
	}
	// Requete de récupération des événements qui commence dans le passé et qui se répète après 00h00 de ce jour
	$apo->db->select($apo->dbPrefix."calendar", "*", "userId=".$apo->userId." AND dateStart < '".date("Y-m-d H:i:s", $currentTimestamp)."' AND (repeatEnd > '".date("Y-m-d H:i:s", $currentTimestamp)."' OR repeatEndNo='on')");
	while($row = $apo->db->fetch_array()){
		$o = $row;
		$o["isRepeat"] = true;
		$events[] = $o;
	}
	
	// Affichage des événements du jour
	for($i=0; $i<count($events); $i++){
		if($events[$i]["isRepeat"]){
			// Evénement de type repeat
			$repeatType = $events[$i]["repeatType"]; // 0=jour, 1=semaine, 2=mois, 3=année
			$repeatStep = $events[$i]["repeatStep"];
			$startTimestamp = strtotime($events[$i]["dateStart"]);
			$startYear = date("Y", $startTimestamp);
			$startMonth = date("n", $startTimestamp);
			$startDay = date("j", $startTimestamp);
			
			// Il faut vérifier si cette répétition tombe aujourd'hui
			$ok = false;
			switch($repeatType){
				case 0:
					$startDayTimestamp = mktime(0, 0, 0, $startMonth, $startDay, $startYear);
					$testTimestamp = $currentTimestamp - $startDayTimestamp;
					if($testTimestamp % ($repeatStep*60*60*24) == 0){
						$ok = true;
					}
					break;
				case 1:
					$startDayTimestamp = mktime(0, 0, 0, $startMonth, $startDay, $startYear);
					$testTimestamp = $dayTimestamp - $startDayTimestamp;
					if($testTimestamp % ($repeatStep*60*60*24*7) == 0){
						$ok = true;
					}
					break;
				case 2:
					if($startDay == $currentDay){
						$ok = true;
					}
					break;
				case 3:
					if($startDay == $currentDay && $startMonth == $currentMonth){
						$ok = true;
					}
					break;
			}
			
			if($ok){
				$title = utf2html(htmlentities($events[$i]["title"], ENT_QUOTES, "UTF-8"));
				$description = nl2br(utf2html(htmlentities($events[$i]["description"], ENT_QUOTES, "UTF-8")));
				$startDayTimestamp = mktime(0, 0, 0, $startMonth, $startDay, $startYear);
				$startTime = floor(($startTimestamp - $startDayTimestamp) / 60);
				$calendarDay_view->addEvent($title, $startTime, 0, $apo->getLink("calendar_eventedit".$events[$i]["id"]), $description, 20, "event".$events[$i]["category"]);
			}
		}else{
			// Evénémenent normal
			$title = utf2html(htmlentities($events[$i]["title"], ENT_QUOTES, "UTF-8"));
			$description = nl2br(utf2html(htmlentities($events[$i]["description"], ENT_QUOTES, "UTF-8")));
			
			$startTimestamp = strtotime($events[$i]["dateStart"]);
			if($startTimestamp < $currentTimestamp){ $startTimestamp = $currentTimestamp; }
			$startTime = floor(($startTimestamp - $currentTimestamp) / 60);
			
			$endTimestamp = strtotime($events[$i]["dateEnd"]);
			if($endTimestamp > $currentTimestamp + 60*60*24){ $endTimestamp = $currentTimestamp + 60*60*24; }
			$endTime = floor(($endTimestamp - $currentTimestamp) / 60);
			
			$lengthTime = $endTime - $startTime;
			$link = (!empty($events[$i]["id"]))?$apo->getLink("calendar_eventedit".$events[$i]["id"]):"#";
			$calendarDay_view->addEvent($title, $startTime, $lengthTime, $link, $description, 20, "event".$events[$i]["category"]);
		}
	}
	
	/* ------------------------------------------------*
	 *                      TODOS                      *
	 *-------------------------------------------------*/
	// Récupération des tâches non-terminées
	$apo->db->select($apo->dbPrefix."todos", "*", "userId=".$apo->userId." AND status < 2", null, null, array("status"=>"ASC"));
	$todosList = array();
	while($row = $apo->db->fetch_array()){
		$o = $row;
		$o["title"] = 			utf2html(htmlentities($o["title"], ENT_QUOTES, "UTF-8"));
		$currentTitleLength = strlen($o["title"]);
		if($currentTitleLength > 24){
			$o["title"] = preg_replace("/(&[^;]*)$/", "", substr($o["title"], 0, 23))."&hellip;";
		}
		$o["description"] = 	nl2br(utf2html(htmlentities($o["description"], ENT_QUOTES, "UTF-8")));
		$todosList[] = $o;
	}
	// --------------------------- Liste des états
	$statusList = array();
	$statusList[] = $apo->getText("calendar_todos_status_0");
	$statusList[] = $apo->getText("calendar_todos_status_1");
	$statusList[] = $apo->getText("calendar_todos_status_2");
	
	// --------------------------- légende
	$legend = "";
	for($i=1; $i<=9; $i++){
		$legend .= "<li class=\"event".$i."\">".$apo->getText("calendar_event_category".$i)."</li>";
	}
	
	// --------------------------- Génération des options
	$formDaySelectOptions = "";
	for($i=1; $i<=31; $i++){
		$formDaySelectOptions .= "<option value=\"".$i."\"";
		if($i == $currentDay){
			$formDaySelectOptions .= " selected=\"selected\"";
		}
		$formDaySelectOptions .= ">".$i."</option>";
	}
	$formMonthSelectOptions = "";
	for($i=1; $i<=12; $i++){
		$formMonthSelectOptions .= "<option value=\"".$i."\"";
		if($i == $currentMonth){
			$formMonthSelectOptions .= " selected=\"selected\"";
		}
		$formMonthSelectOptions .= ">".$monthNames[$i - 1]."</option>";
	}
	$formYearSelectOptions = "";
	for($i=1970; $i<=2020; $i++){
		$formYearSelectOptions .= "<option value=\"".$i."\"";
		if($i == $currentYear){
			$formYearSelectOptions .= " selected=\"selected\"";
		}
		$formYearSelectOptions .= ">".$i."</option>";
	}
}
?>