<?php
if($apo->loged){
	import("com.neolao.components.CalendarYear");
	include_once dirname(__FILE__)."/../general/functions_html.inc";
	include_once dirname(__FILE__)."/functions.inc";
	
	// Récupération des paramètres
	$year = FormUtils::getParam("year");
	$year = ($year !== false)?$year:date("Y");
	
	$calendarYear_view = new CalendarYear("calendar_year_view");
	$calendarYear_view->title = $apo->getText("calendar_menu_year")." ".$year;
	$calendarYear_view->dayNames = $dayNamesShort;
	$monthNamesNew = array();
	for($i=0; $i<count($monthNames); $i++){
		$monthNamesNew[$i] = "<a href=\"".$apo->webIndex."?p=calendar&amp;year=".$year."&amp;month=".($i + 1)."&amp;day=1\">".$monthNames[$i]."</a>";
	}
	$calendarYear_view->monthNames = $monthNamesNew;
	$calendarYear_view->dayLinkFormat = $apo->webIndex."?p=calendar&amp;year=%d&amp;month=%d&amp;day=%d";
	
	$calendarYear_view->year = $year;
	$calendarYear_view->addNextYear($apo->webIndex."?p=calendar_year&amp;year=".($year + 1));
	$calendarYear_view->addPreviousYear($apo->webIndex."?p=calendar_year&amp;year=".($year - 1));
	
	$events = array();
	// Requete de récupération des événements qui commence cette année
	$apo->db->select($apo->dbPrefix."calendar", "*", "userId=".$apo->userId." AND dateStart LIKE '".$year."-%'");
	while($row = $apo->db->fetch_array()){
		$events[$row["id"]] = $row;
	}
	// Requete de récupération des événements qui commence dans le passé et qui dépasse le 1 janvier de cette année
	$apo->db->select($apo->dbPrefix."calendar", "*", "userId=".$apo->userId." AND dateStart < '".$year."-01-01 00:00:00' AND dateEnd > '".$year."-01-01 00:00:00'");
	while($row = $apo->db->fetch_array()){
		$events[$row["id"]] = $row;
	}
	// Requete de récupération des événements qui se répète après le 1 janvier de cette année
	$apo->db->select($apo->dbPrefix."calendar", "*", "userId=".$apo->userId." AND (repeatEnd > '".$year."-01-01 00:00:00' OR repeatEndNo='on')");
	while($row = $apo->db->fetch_array()){
		$o = $row;
		$o["isRepeat"] = true;
		$events[$row["id"]] = $o;
	}
	
	// On range $events
	$events_temp = array();
	while(list($key, $value) = each($events)){
		$events_temp[] = $value;
	}
	$events = $events_temp;
	
	// Requete de récupération des anniversaires dans la table contacts
	$apo->db->select($apo->dbPrefix."contacts", "*", "userId=".$apo->userId);
	$contactsList = array();
	while($row = $apo->db->fetch_array()){
		$contactsList[] = $row;
	}
	for($i=0; $i<count($contactsList); $i++){
		$o = $contactsList[$i];
		$ok = false;
		if($o["birthday"] > "1970-01-01"){
			// La date est valide
			$ok = true;
		}else{
			// La date n'est pas valide, on va chercher si c'est un anniversaire synchronisé
			$apo->db->select($apo->dbPrefix."users", "*", "name='".$o["nickName"]."'");
			$row = $apo->db->fetch_array();
			if($row !== false){
				// L'utilisateur existe, on récupère ses informations
				$apo->db->select($apo->dbPrefix."users_infos", "birthday", "userId=".$row["id"]);
				$row = $apo->db->fetch_array();
				if($row["birthday"] > "1970-01-01"){
					// Il n'y a aucune vérification sur l'appartenance au groupe
					// Il est donc possible de connaître l'anniversaire de n'importe qui (super intéressant lol)
					$o = $row;
					$o["name"] = $contactsList[$i]["name"];
					$ok = true;
				}
			}
		}
		if($ok){
			$o["title"] = $apo->getText("calendar_event_category2")." : ".$o["name"];
			$o["description"] = "";
			$o["dateStart"] = $year.substr($o["birthday"], 4);
			$o["dateEnd"] = $year.substr($o["birthday"], 4);
			$o["category"] = "2";
			$o["id"] = "";
			$events[] = $o;
		}
	}
	
	// Affichage des événements du jour
	for($i=0; $i<count($events); $i++){
		if($events[$i]["isRepeat"]){
			// Evénement de type repeat
			$repeatType = $events[$i]["repeatType"]; // 0=jour, 1=semaine, 2=mois, 3=année
			$repeatStep = $events[$i]["repeatStep"];
			$repeatEnd = $events[$i]["repeatEnd"];
			$endTimestamp = strtotime($repeatEnd);
			$repeatEndNo = ($events[$i]["repeatEndNo"] == "on")?true:false;
			$startTimestamp = strtotime($events[$i]["dateStart"]);
			$startYear = date("Y", $startTimestamp);
			$startMonth = date("n", $startTimestamp);
			$startDay = date("j", $startTimestamp);
			
			$firstDayTimestamp = mktime(0, 0, 0, 1, 1, $year);
			$lastDayTimestamp = mktime(0, 0, 0, 12, 31, $year);
			
			// Il faut vérifier si cette répétition tombe cette année
			$title = utf2html(htmlentities($events[$i]["title"], ENT_QUOTES, "UTF-8"));
			$description = nl2br(utf2html(htmlentities($events[$i]["description"], ENT_QUOTES, "UTF-8")));
			$length = 1;
			
			switch($repeatType){
				case 0:
					// Il faut vérifier tous les jours jusqu'à la date de fin
					$n = 0;
					$a = $startTimestamp + $n*60*60*24;
					while(($a < $endTimestamp || $repeatEndNo) && $a < $lastDayTimestamp){
						if($a > $firstDayTimestamp){
							$month = date("n", $a);
							$day = date("j", $a);
							$calendarYear_view->addEvent($title, $month, $day, $length, $apo->getLink("calendar_eventedit".$events[$i]["id"]), $description, "event".$events[$i]["category"]);
						}
						$n += $repeatStep;
						$a = $startTimestamp + $n*60*60*24;
					}
					break;
				case 1:
					// Il faut vérifier toutes les semaines jusqu'à la date de fin
					$n = 0;
					$a = $startTimestamp + $n*60*60*24*7;
					while(($a < $endTimestamp || $repeatEndNo) && $a < $lastDayTimestamp){
						if($a > $firstDayTimestamp){
							$month = date("n", $a);
							$day = date("j", $a);
							$calendarYear_view->addEvent($title, $month, $day, $length, $apo->getLink("calendar_eventedit".$events[$i]["id"]), $description, "event".$events[$i]["category"]);
						}
						$n += $repeatStep;
						$a = $startTimestamp + $n*60*60*24*7;
					}
					break;
				case 2:
					// Il faut vérifier tous les mois jusqu'à la date de fin
					$n = 0;
					$a = mktime(0, 0, 0, $startMonth+$n, $startDay, $startYear);
					while(($a < $endTimestamp || $repeatEndNo) && $a < $lastDayTimestamp){
						if($a > $firstDayTimestamp){
							$month = date("n", $a);
							$day = date("j", $a);
							if($day == $startDay){
								$calendarYear_view->addEvent($title, $month, $day, $length, $apo->getLink("calendar_eventedit".$events[$i]["id"]), $description, "event".$events[$i]["category"]);
							}
						}
						$n += $repeatStep;
						$a = mktime(0, 0, 0, $startMonth+$n, $startDay, $startYear);
					}
					break;
				case 3:
					// Il faut vérifier tous les ans jusqu'à la date de fin
					$n = 0;
					$a = mktime(0, 0, 0, $startMonth, $startDay, $startYear+$n);
					while(($a < $endTimestamp || $repeatEndNo) && $a < $lastDayTimestamp){
						if($a > $firstDayTimestamp){
							$month = date("n", $a);
							$day = date("j", $a);
							if($month == $startMonth && $day == $startDay){
								$calendarYear_view->addEvent($title, $month, $day, $length, $apo->getLink("calendar_eventedit".$events[$i]["id"]), $description, "event".$events[$i]["category"]);
							}
						}
						$n += $repeatStep;
						$a = mktime(0, 0, 0, $startMonth, $startDay, $startYear+$n);
					}
					break;
			}
		}else{
			// Evénémenent normal
			$title = utf2html(htmlentities($events[$i]["title"], ENT_QUOTES, "UTF-8"));
			$description = nl2br(utf2html(htmlentities($events[$i]["description"], ENT_QUOTES, "UTF-8")));
			
			$startTimestamp = strtotime($events[$i]["dateStart"]);
			if($startTimestamp < mktime(0, 0, 0, 1, 1, $year)){ $startTimestamp = mktime(0, 0, 0, 1, 1, $year); }
			$startMonth = date("n", $startTimestamp);
			$startDay = date("j", $startTimestamp);
			$startDayTimestamp = mktime(0, 0, 0, $startMonth, $startDay, $year);
			
			$endTimestamp = strtotime($events[$i]["dateEnd"]);
			$endMonth = date("n", $endTimestamp);
			$endDay = date("j", $endTimestamp);
			$endDayTimestamp = mktime(0, 0, 0, $endMonth, $endDay, $year);
			
			$length = $endDayTimestamp - $startDayTimestamp + 1;
			$length = ceil($length / (60*60*24));
			
			$link = (!empty($events[$i]["id"]))?$apo->getLink("calendar_eventedit".$events[$i]["id"]):"#";
			
			$calendarYear_view->addEvent($title, $startMonth, $startDay, $length, $link, $description, "event".$events[$i]["category"]);
		}
	}
	
	// légende
	$legend = "";
	for($i=1; $i<=9; $i++){
		$legend .= "<li class=\"event".$i."\">".$apo->getText("calendar_event_category".$i)."</li>";
	}
}
?>