<?php
	/**
	 * Formate un contact au format LDIF
	 * @param array $contact Les détails du contact dans un tableau
	 * @return string Le format LDI du contact 
	 */
	function formatLDIF($contact){
		$result = "";
		
		// DN = Distinguished Name
		$result .= "dn: ";
		$result .= "cn=";
		$result .= (!empty($contact["name"]))?$contact["name"]:"";
		//$result .= (!empty($contact["email"]))?",mail=".$contact["email"]:"";
		$result .= "\n";
		
		// Objectclass
		$result .= "objectclass: top\n";
		$result .= "objectclass: person\n";
		$result .= "objectclass: organizationalPerson\n";
		$result .= "objectclass: inetOrgPerson\n";
		$result .= "objectclass: mozillaAbPersonObsolete\n";
		
		
		$result .= (!empty($contact["firstName"]))?"givenName: ".$contact["firstName"]."\n":"";
		// surname
		$result .= (!empty($contact["lastName"]))?"sn: ".$contact["lastName"]."\n":"";
		// common name
		$result .= (!empty($contact["name"]))?"cn: ".$contact["name"]."\n":"";
		$result .= (!empty($contact["nickName"]))?"xmozillanickname: ".$contact["nickName"]."\n":"";
		$result .= (!empty($contact["email"]))?"mail: ".$contact["email"]."\n":"";
		$result .= (!empty($contact["email2"]))?"mozillaSecondEmail: ".$contact["email2"]."\n":"";
		$result .= "modifytimestamp: 0Z\n";
		$result .= (!empty($contact["phoneWork"]))?"telephoneNumber: ".$contact["phoneWork"]."\n":"";
		$result .= (!empty($contact["phoneHome"]))?"homePhone: ".$contact["phoneHome"]."\n":"";
		$result .= (!empty($contact["phoneCell"]))?"mobile: ".$contact["phoneCell"]."\n":"";
		$result .= (!empty($contact["adress"]))?"homePostalAddress: ".$contact["adress"]."\n":"";
		$result .= (!empty($contact["adress2"]))?"mozillaHomePostalAddress2: ".$contact["adress2"]."\n":"";
		$result .= (!empty($contact["city"]))?"mozillaHomeLocalityName: ".$contact["city"]."\n":"";
		$result .= (!empty($contact["state"]))?"mozillaHomeState: ".$contact["state"]."\n":"";
		$result .= (!empty($contact["adresscode"]))?"mozillaHomePostalCode: ".$contact["adresscode"]."\n":"";
		$result .= (!empty($contact["country"]))?"mozillaHomeCountryName: ".$contact["country"]."\n":"";
		$result .= (!empty($contact["workAdress"]))?"postalAddress: ".$contact["workAdress"]."\n":"";
		$result .= (!empty($contact["workAdress2"]))?"mozillaPostalAddress2: ".$contact["workAdress2"]."\n":"";
		// locality name
		$result .= (!empty($contact["workCity"]))?"l: ".$contact["workCity"]."\n":"";
		$result .= (!empty($contact["workState"]))?"st: ".$contact["workState"]."\n":"";
		$result .= (!empty($contact["workAdresscode"]))?"postalCode: ".$contact["workAdresscode"]."\n":"";
		$result .= (!empty($contact["workCountry"]))?"c: ".$contact["workCountry"]."\n":"";
		$result .= (!empty($contact["workJob"]))?"title: ".$contact["workJob"]."\n":"";
		// organizational unit name
		$result .= (!empty($contact["workDepartment"]))?"ou: ".$contact["workDepartment"]."\n":"";
		// organization name
		$result .= (!empty($contact["workCompany"]))?"o: ".$contact["workCompany"]."\n":"";
		$result .= (!empty($contact["workWebsite"]))?"workurl: ".$contact["workWebsite"]."\n":"";
		$result .= (!empty($contact["website"]))?"homeurl: ".$contact["website"]."\n":"";
		// description
		$result .= (!empty($contact["note"]))?"description:: ".base64_encode($contact["note"])."\n":"";
		
		return $result;
	}
?>