<?php
if($apo->loged){
	include_once dirname(__FILE__)."/../general/functions_html.inc";
	
	// Requête
	$apo->db->select($apo->dbPrefix."contacts", "*", "userId=".$apo->userId, null, null, array("name"=>"ASC"));
	$contactsList = array();
	while($row = $apo->db->fetch_array()){
		$contactsList[] = $row;
	}
	while(list($key, $row) = each($contactsList)){
		// On vérifie s'il existe un membre ayant le même surnom
		$apo->db->select($apo->dbPrefix."users", "*", "name='".$row["nickName"]."'");
		$ok =  $apo->db->fetch_array();
		if($ok !== false){
			$apo->db->select($apo->dbPrefix."users_infos", "*", "userId=".$ok["id"]);
			$apoUser = $apo->db->fetch_array();
			// On vérifie que l'utilisateur a le droit de voir le profil
			$memberLevel = (int) $apoUser["level"];
			switch($memberLevel){
				default:
				case 0:
					// privé
					unset($apoUser);
					break;
				case 1:
					// groupe
					// Il faut vérifier que l'utilisateur fait partie du même groupe
					$apo->db->select($apo->dbPrefix."users_groups", "groupId", "userId=".$apoUser["userId"]);
					$listGroup1 = $apo->db->fetch_array();
					$apo->db->select($apo->dbPrefix."users_groups", "groupId", "userId=".$apo->userId);
					$listGroup2 = $apo->db->fetch_array();
					$listIntersect = array_intersect($listGroup1, $listGroup2);
					if(count($listIntersect) == 0){
						unset($apoUser);
					}
					break;
				case 2:
					// public
			}
		}else{
			unset($apoUser);
		}
		
		// échappement des caractères
		$o = array();
		while(list($k, $value) = each($row)){
			if(empty($value) && !empty($apoUser[$k]) || ($k == "birthday" && $value == "1970-01-01")){
				// Il existe un membre et le champ est vide
				$o[$k] = utf2html(htmlentities($apoUser[$k], ENT_QUOTES, "UTF-8"));
			}else{
				$o[$k] = utf2html(htmlentities($value, ENT_QUOTES, "UTF-8"));
			}
		}
		
		// affichage des détails
		$details = "";
		// Identité
		$details .= "<fieldset>";
		$details .= 	"<legend>".$apo->getText("contacts_fieldset_id")."</legend>";
		$details .= 	"<ul>";
		if(!empty($o["firstName"])){ $details .= "<li><label>".$apo->getText("contacts_fieldset_id_firstname")."</label>".$o["firstName"]."</li>"; }
		if(!empty($o["lastName"])){ $details .= "<li><label>".$apo->getText("contacts_fieldset_id_lastname")."</label>".$o["lastName"]."</li>"; }
		if(!empty($o["nickName"])){ $details .= "<li><label>".$apo->getText("contacts_fieldset_id_nickname")."</label>".$o["nickName"]."</li>"; }
		if($o["birthday"]>"1970-01-01"){ $details .= "<li><label>".$apo->getText("contacts_fieldset_id_birthday")."</label>".date("d/m/Y", strtotime($o["birthday"]))."</li>"; }
		$details .= 	"</ul>";
		$details .= "</fieldset>";
		// Email
		$details .= "<fieldset>";
		$details .= 	"<legend>".$apo->getText("contacts_fieldset_mail")."</legend>";
		$details .= 	"<ul>";
		if(!empty($o["email"])){ $details .= "<li><label>".$apo->getText("contacts_fieldset_mail_mail1")."</label>".$o["email"]."</li>"; }
		if(!empty($o["email2"])){ $details .= "<li><label>".$apo->getText("contacts_fieldset_mail_mail2")."</label>".$o["email2"]."</li>"; }
		$details .= 	"</ul>";
		$details .= "</fieldset>";
		// Téléphones
		$details .= "<fieldset>";
		$details .= 	"<legend>".$apo->getText("contacts_fieldset_phone")."</legend>";
		$details .= 	"<ul>";
		if(!empty($o["phoneHome"])){ $details .= "<li><label>".$apo->getText("contacts_fieldset_phone_home")."</label>".$o["phoneHome"]."</li>"; }
		if(!empty($o["phoneCell"])){ $details .= "<li><label>".$apo->getText("contacts_fieldset_phone_cell")."</label>".$o["phoneCell"]."</li>"; }
		if(!empty($o["phoneWork"])){ $details .= "<li><label>".$apo->getText("contacts_fieldset_phone_work")."</label>".$o["phoneWork"]."</li>"; }
		$details .= 	"</ul>";
		$details .= "</fieldset>";
		// Adresse
		$details .= "<fieldset>";
		$details .= 	"<legend>".$apo->getText("contacts_fieldset_adresshome")."</legend>";
		$details .= 	"<ul>";
		if(!empty($o["adress"])){ $details .= "<li><label>".$apo->getText("contacts_fieldset_adresshome_adress1")."</label>".$o["adress"]."</li>"; }
		if(!empty($o["adress2"])){ $details .= "<li><label>".$apo->getText("contacts_fieldset_adresshome_adress2")."</label>".$o["adress2"]."</li>"; }
		if(!empty($o["city"])){ $details .= "<li><label>".$apo->getText("contacts_fieldset_adresshome_city")."</label>".$o["city"]."</li>"; }
		if(!empty($o["state"])){ $details .= "<li><label>".$apo->getText("contacts_fieldset_adresshome_state")."</label>".$o["state"]."</li>"; }
		if(!empty($o["adresscode"])){ $details .= "<li><label>".$apo->getText("contacts_fieldset_adresshome_code")."</label>".$o["adresscode"]."</li>"; }
		if(!empty($o["country"])){ $details .= "<li><label>".$apo->getText("contacts_fieldset_adresshome_country")."</label>".$o["country"]."</li>"; }
		if(!empty($o["website"])){ $details .= "<li><label>".$apo->getText("contacts_fieldset_adresshome_website")."</label>".$o["website"]."</li>"; }
		$details .= 	"</ul>";
		$details .= "</fieldset>";
		// work
		$details .= "<fieldset>";
		$details .= 	"<legend>".$apo->getText("contacts_fieldset_adresswork")."</legend>";
		$details .= 	"<ul>";
		if(!empty($o["workJob"])){ $details .= "<li><label>".$apo->getText("contacts_fieldset_adresswork_job")."</label>".$o["workJob"]."</li>"; }
		if(!empty($o["workDepartment"])){ $details .= "<li><label>".$apo->getText("contacts_fieldset_adresswork_department")."</label>".$o["workDepartment"]."</li>"; }
		if(!empty($o["workCompany"])){ $details .= "<li><label>".$apo->getText("contacts_fieldset_adresswork_company")."</label>".$o["workCompany"]."</li>"; }
		if(!empty($o["workAdress"])){ $details .= "<li><label>".$apo->getText("contacts_fieldset_adresswork_adress1")."</label>".$o["workAdress"]."</li>"; }
		if(!empty($o["workAdress2"])){ $details .= "<li><label>".$apo->getText("contacts_fieldset_adresswork_adress2")."</label>".$o["workAdress2"]."</li>"; }
		if(!empty($o["workCity"])){ $details .= "<li><label>".$apo->getText("contacts_fieldset_adresswork_city")."</label>".$o["workCity"]."</li>"; }
		if(!empty($o["workState"])){ $details .= "<li><label>".$apo->getText("contacts_fieldset_adresswork_state")."</label>".$o["workState"]."</li>"; }
		if(!empty($o["workAdresscode"])){ $details .= "<li><label>".$apo->getText("contacts_fieldset_adresswork_code")."</label>".$o["workAdresscode"]."</li>"; }
		if(!empty($o["workCountry"])){ $details .= "<li><label>".$apo->getText("contacts_fieldset_adresswork_country")."</label>".$o["workCountry"]."</li>"; }
		if(!empty($o["workWebsite"])){ $details .= "<li><label>".$apo->getText("contacts_fieldset_adresswork_website")."</label>".$o["workWebsite"]."</li>"; }
		$details .= 	"</ul>";
		$details .= "</fieldset>";
		// note
		$details .= "<fieldset>";
		$details .= "<legend>".$apo->getText("contacts_fieldset_bonus")."</legend>";
		$details .= 	"<div>";
		$details .= 		nl2br($o["note"]);
		$details .= 	"</div>";
		$details .= "</fieldset>";
		$o["details"] = $details;
		
		// affectation
		$contactsList[$key] = $o;
	}
	reset($contactsList);
}
?>