<?php
if($apo->loged){
	// Récupération des groupes de l'utilisateur
	$apo->db->select($apo->dbPrefix."users_groups", "groupId", "userId=".$apo->userId);
	$listGroups = array();
	while($row = $apo->db->fetch_array()){
		$listGroups[] = $row["groupId"];
	}
	
	// Création de la requête pour récupérer tous les articles des utilisateurs des groupes
	$requestWhere = array();
	for($i=0; $i<count($listGroups); $i++){
		$requestWhere[] = "c.groupId=".$listGroups[$i];
	}	
	$apo->db->select(array($apo->dbPrefix."news"." AS a", $apo->dbPrefix."users"." AS b", $apo->dbPrefix."users_groups"." AS c"), 
					array("a.id AS id", "a.categoryId AS categoryId", "a.date AS date", "a.title AS title", "a.message AS message", "b.name AS userName"), 
					"(".implode(" OR ", $requestWhere).") AND c.userId=a.userId AND c.userId=b.id", 
					"a.id", 
					null, 
					array("a.date"=>"DESC"), 
					array(0, $apo->userPreferences["news_total"]));
	
	$listNews = array();
	while($row = $apo->db->fetch_array()){
		$listNews["new".$row["id"]] = $row;
	}
	
	// Pour chaque article, je cherche le nombre de commentaires et la catégorie associée
	while(list($key, $value) = each($listNews)){
		$apo->db->select($apo->dbPrefix."news_comments", "COUNT(*) AS total", "newsId=".$value["id"]);
		$listNews[$key]["commentsTotal"] = $apo->db->fetch_single();
		$apo->db->select($apo->dbPrefix."news_categories", "*", "id=".$value["categoryId"]);
		$row = $apo->db->fetch_array();
		$listNews[$key]["category"] =  utf8_encode($row["nameClass"]);
	}
	reset($listNews);
	
	// Et maintenant un traitement des textes pour l'affichage
	include_once dirname(__FILE__)."/../general/functions_wiki.inc";
	include_once dirname(__FILE__)."/../general/functions_date.inc";
	include_once dirname(__FILE__)."/../general/functions_html.inc";
	while(list($key, $value) = each($listNews)){
		$listNews[$key]["title"] = utf2html(htmlentities($listNews[$key]["title"], ENT_QUOTES, "UTF-8"));
		$listNews[$key]["message"] = utf2html(htmlentities($listNews[$key]["message"], ENT_QUOTES, "UTF-8"));
		$listNews[$key]["message"] = wiki_format($listNews[$key]["message"]);
		// Tronquer le texte si c'est trop long
		if(strlen($listNews[$key]["message"]) > 1000){
			$messageTemp = substr($listNews[$key]["message"], 0, 1000);
			if(strrpos($messageTemp, "</p>") !== false){
				$listNews[$key]["message"] = substr($messageTemp, 0, strrpos($messageTemp, "</p>")+4);
				$listNews[$key]["message"] .= "<p><a href=\"".$apo->getLink("news_comments".$listNews[$key]["id"] )."\">".$apo->getText("news_read_all")."</a></p>";
			}else if(strrpos($messageTemp, "<br />") !== false){
				$listNews[$key]["message"] = substr($messageTemp, 0, strrpos($messageTemp, "<br />"));
				$listNews[$key]["message"] .= "</p><p><a href=\"".$apo->getLink("news_comments".$listNews[$key]["id"] )."\">".$apo->getText("news_read_all")."</a></p>";
			}
		}
		
		$listNews[$key]["userName"] = $listNews[$key]["userName"];
		$listNews[$key]["date"] = formatDate($listNews[$key]["date"]);
		$listNews[$key]["comments"] = "<a href=\"".$apo->getLink("news_comments".$listNews[$key]["id"])."\">";
		$listNews[$key]["comments"] .= $listNews[$key]["commentsTotal"]." ".$apo->getText("news_comments");
		$listNews[$key]["comments"] .= "</a>";
	}
	reset($listNews);
}
?>