<?php
	include_once dirname(__FILE__)."/../general/functions_wiki.inc";
	include_once dirname(__FILE__)."/../general/functions_html.inc";
	
	function rss_getList($listRss){
		global $apo;
		if($apo->loged){
			$content = "<div class=\"options\"><a href=\"".$apo->getLink("rss_readall")."\">".$apo->getText("rss_readedall")."</a></div>\n";
		}
		$n = 0;
		$addArchives = array();
		for($i=0; $i<count($listRss); $i++){
			if(is_array($listRss[$i]["magpie"]->items)){
				$list = each($listRss[$i]["magpie"]->items);
				list($k, $item) = $list;
				$pubdate = $item["pubdate"];
				$dc = $item["dc"];
				$dc_date = $dc["date"];
				if(!empty($dc_date)){
					$date = $dc_date;
				}else if(!empty($pubdate)){
					$date = $pubdate;
				}
				if (($timestamp = strtotime($date)) !== -1) {
					$dateTime = date("Y-m-d H:i:s",$timestamp);
				}
				
				if($listRss[$i]["lastCheck"] < $dateTime){
					// Il a des nouveaux items
					@reset($listRss[$i]["magpie"]->items);
					$content .= "\n<fieldset>\n";
					$content .= "	<legend>".$listRss[$i]["name"]."</legend>\n";
					if($apo->loged){
						$content .= "<div class=\"options\"><a href=\"".$apo->getLink("rss_read".$listRss[$i]["id"])."\">".$apo->getText("rss_readed")."</a></div>\n";
					}
					$content .= "	<dl>\n";
					foreach ($listRss[$i]["magpie"]->items as $item) {
						$n++;
						// dc s'il y a
						$dc = $item["dc"];
						
						// Lien
						$href = htmlentities($item["link"]);
						
						// Titre
						$title = iso2html(htmlentities(html_entity_decode($item["title"])));
						
						// Catégorie
						$categorie = "";
						if(!empty($item["category"])){
							$categorie = " - ".iso2html(htmlentities(html_entity_decode($item["category"])));
						}
						
						// date
						$pubdate = $item["pubdate"];
						$dc_date = $dc["date"];
						$modified = $item["modified"];
						$issued = $item["issued"];
						if(!empty($dc_date)){
							$date = $dc_date;
						}else if(!empty($pubdate)){
							$date = $pubdate;
						}else if(!empty($modified)){
							$date = $modified;
						}else if(!empty($issued)){
							$date = $issued;
						}
						$dateTime = "0000-00-00 00:00:01";$dateError = false;
						if (($timestamp = strtotime($date)) === -1) {
							$dateError = true;
							$date = $date." (".$apo->getText("error1").")";
							$dateTime = "0000-00-00 00:00:01";
						} else {
							$date = date("d/m/Y H:i",$timestamp);
							$dateTime = date("Y-m-d H:i:s",$timestamp);
							if($dateTime > date("Y-m-d H:i:s")){
								$dateError = true;
								$date = $date." (".$apo->getText("error2").")";
								$dateTime = "0000-00-00 00:00:01";
							}
						}
						
						// auteur
						$author = "";
						if(!empty($item["author"])){
							$author = " - ".iso2html(htmlentities($item["author"]));
						}else if(!empty($dc["author"])){
							$author = " - ".iso2html(htmlentities($dc["author"]));
						}else if(!empty($dc["creator"])){
							$author = " - ".iso2html(htmlentities($dc["creator"]));
						}
						
						// description
						$description = rss_description_format($item["description"]);
						
						// affichage
						if($listRss[$i]["lastCheck"] < $dateTime || $dateError){
							$content .= "		<dt>";
							$content .= 		"[<a href=\"javascript:switchDisplay('description".$n."')\">+</a>] <a href=\"".$href."\">".$title."</a>";
							$content .= "		</dt>\n";
							$content .= "		<dd class=\"description\" id=\"description".$n."\">\n";
							$content .= "			<h3>".$date.$categorie.$author."</h3>\n";
							$content .= "			\n";
							$content .= "			".$description;
							$content .= "			\n";
							$content .= "		</dd>\n";
						}
						
						// Enregistrement dans les archives
						if($listRss[$i]["lastArchive"] < $dateTime){
							$addArchives[] = array("'".$listRss[$i]["url"]."'", "'".$dateTime."'", "'".$item["link"]."'", "'".addslashes($item["title"])."'", "'".addslashes($item["description"])."'");
						}
					}
					$content .= "	</dl>\n";
					$content .= "</fieldset>\n";
				}
			}else{
				// Erreur de parsing XML
				$apo->error = "ERROR PARSING XML";
			}
		}
		// Enregistrement dans les archives
		if(count($addArchives) > 0){
			$apo->db->replace($apo->dbPrefix."rss_archives", 
							array("url", "date", "link", "title", "description"), 
							$addArchives);
		}
		if($apo->loged){
			$content .= "<div class=\"options\"><a href=\"".$apo->getLink("rss_readall")."\">".$apo->getText("rss_readedall")."</a></div>\n";
		}
		return array("total"=>$n, "content"=>$content);
	}
	
	function rss_description_format($htmlText){
		$patterns = array();
		$replacements = array();
		
		// BR
		$patterns[] = "_<br ?/>_";
		$replacements[] = "\n";
		
		// P
		$patterns[] = "_<p>_";
		$replacements[] = "\n";
		$patterns[] = "_</p>_";
		$replacements[] = "";
		
		// A
		$patterns[] = '_<a([^>]*)href=("|\')([^"\']+)("|\')([^>]*)>(.*?)</a>_';
		$replacements[] = "[[$3|$6]]";
		
		// IMG
		$patterns[] = '_<img([^>]*)src=("|\')([^("|\')]*)("|\')([^>]*)>_';
		$replacements[] = "(($3))";
		
		$htmlText = preg_replace($patterns, $replacements, $htmlText);
		
		Wiki2html::setOption("em", false);
		$htmlText = iso2html(htmlentities(html_entity_decode($htmlText)));
		
		return wiki_format($htmlText);
	}
	
?>